unit EvalLbl;

interface

uses Classes,Controls,DsgnIntf,stdctrls;

type
    TEvalLabel = class (TCustomLabel)
    private
          procedure SetEvalLabelVisible(Value:Boolean);
    public
          constructor Create(AOwner:TComponent); override;
    published
          property Alignment;
          property AutoSize;
          property Visible Write SetEvalLabelVisible;
          property Font;
          property ParentFont;
          property WordWrap;
          property Caption;
          property Color;
    end;

    TEvalEdit = class(TCustomEdit)
    private
          procedure SetEvalEditVisible(Value:Boolean);
    published
          property OnChange;   
          property Visible Write SetEvalEditVisible;
    end;

    TEvalLabelProperty = class(TClassProperty)
    public
        function GetAttributes:TPropertyAttributes; override;
    end;

    TEvalEditProperty = class(TClassProperty)
    public
        function GetAttributes:TPropertyAttributes; override;
    end;

implementation

uses EvalExPa,EvalPar;


constructor TEvalLabel.Create(AOwner:TComponent);
begin
     inherited Create(AOwner);
end;


procedure TEvalLabel.SetEvalLabelVisible(Value:Boolean);
begin
     inherited Visible:=Value;
     if Parent is TEvalFnPanel then
        TEvalFnPanel(Parent).ArrangeControls;
end;

procedure TEvalEdit.SetEvalEditVisible(Value:Boolean);
begin
     inherited Visible:=Value;
     if Parent is TEvalParams then
        TEvalParams(Parent).ArrangeControls;
end;


function TEvalLabelProperty.GetAttributes:TPropertyAttributes;
begin
     Result:=[paSubProperties,paReadOnly,paMultiSelect];
end;

function TEvalEditProperty.GetAttributes:TPropertyAttributes;
begin
     Result:=[paMultiSelect, paSubProperties, paReadOnly];
end;


end.
 