unit EvalPar;

interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls,StdCtrls,EValDefs,EvalCom,DB,Buttons,
  Eval,EvalLbl;

const MaxCtrls = 6;
type

  TListStyle    = (lsFieldNames, lsFieldLabels);

  TEvalParams   = class;

  TEvalLabelType=(ptLabel1,ptLabel2,ptLabel3,
                  ptLabel4,ptLabel5,ptLabel6,
                  ptEvalEdit);

  TSubFunctionEvent = procedure(Sender:TObject; ParamBox:TComboBox;
       var Dialog:Boolean) of object;

  TEvalParams=Class(TPanel)
  private
      FOnFunctionChange                   : TNotifyEvent;
      FOnExpressionChange                 : TNotifyEvent;
      FSelectedFunction                   : TEvalSymbol;
      FEval                               : TEval;
      FOnSubfunction                      : TSubFunctionEvent;
      FSubBtnVisible                      : Boolean;
      FLabelsVisible                      : Boolean;
      FDistance                           : Integer;
      FListStyle                          : TListStyle;
      procedure CBChange(Sender: TObject);
      procedure CBEnter(Sender:TObject);
      procedure BtnClick(Sender: TObject);
      function  GetExpression:String;
      procedure SetExpression(Value:String);
      procedure SetSelectedFunction(Value:TEvalSymbol);
      procedure InitializeCombos;
      procedure CreateControls;
      procedure SetEval(Value:TEval);
      procedure SetSubBtnVisible(Value:Boolean);
      procedure SetLabelsVisible(Value:Boolean);
      procedure SetListStyle(Value:TListStyle);
      // function  GetArgLabel(Index:Integer):TEvalLabel;
      // procedure SetArgLabel(Index:Integer; Value:TEvalLabel);
      // procedure SetEvalEdit(Value:TEvalEdit);
  protected
      procedure   Notification(AComponent: TComponent; Operation: TOperation); override;
      procedure   RekalkExpr;
      procedure   SetDistance(Value:Integer);
      function    ParamCount:Integer;
      procedure   Loaded;            override;
  public
      ArgLabel  : Array [0..MaxCtrls-1] of TEvalLabel;
      ArgBtn    : Array [0..MaxCtrls-1] of TSpeedButton;
      ArgCombo  : Array [0..MaxCtrls-1] of TEvalCombo;
      FEvalEdit : TEvalEdit;
      Level     : Integer;
      constructor Create(AOwner:TComponent); override;
      procedure   CreateWindowHandle(const Params:TCreateParams); override;
      procedure   LoadFields(C:TEvalCombo);
      procedure   ArrangeControls;
      procedure   SetBounds(ALeft, ATop, AWidth, AHeight: Integer); override;
  published
      property Eval : TEval Read FEval Write SetEval;
      property SelectedFunction:TEvalSymbol   Read  FSelectedFunction
                                              Write SetSelectedFunction;
      property Expression:String Read GetExpression Write SetExpression;
      property SubBtnVisible : Boolean Read FSubBtnVisible Write SetSubBtnVisible;
      property LabelsVisible : Boolean Read FLabelsVisible Write SetLabelsVisible;
      property Distance      : Integer Read FDistance      Write SetDistance;
      property ListStyle     : TListStyle Read FListStyle     Write SetListStyle;
      {property Arg0Label     : TEvalLabel Index 0 Read GetArgLabel Write SetArgLabel;
      property Arg1Label     : TEvalLabel Index 1 Read GetArgLabel Write SetArgLabel;
      property Arg2Label     : TEvalLabel Index 2 Read GetArgLabel Write SetArgLabel;
      property Arg3Label     : TEvalLabel Index 3 Read GetArgLabel Write SetArgLabel;
      property Arg4Label     : TEvalLabel Index 4 Read GetArgLabel Write SetArgLabel;
      property Arg5Label     : TEvalLabel Index 5 Read GetArgLabel Write SetArgLabel;
      property EvalEdit      : TEvalEdit  Read FEvalEdit Write SetEvalEdit stored True;
      }property OnFunctionChange     :TNotifyEvent Read  FOnFunctionChange
                                                  Write FOnFunctionChange;
      property OnSubfunction        :TSubFunctionEvent Read  FOnSubfunction
                                                       Write FOnSubfunction;
      property OnExpressionChange   :TNotifyEvent      Read  FOnExpressionChange
                                                       Write FOnExpressionChange;
    end;


implementation

uses EvalRes,EvalSub;

{$R EvalPar.Res}

constructor TEvalParams.Create(Aowner:TComponent);
begin
     inherited Create(AOwner);
     CreateControls;

     Width           := 315;
     Height          := 155;
     Caption         := '';
     Level           := 1;
     FDistance       := 2;
     FSubBtnVisible  := True;
     FLabelsVisible  := True;
end;

procedure TEvalParams.CreateWindowHandle(const Params:TCreateParams);
begin
     inherited CreateWindowHandle(Params);
     ArrangeControls;
     Caption := '';
end;

procedure   TEvalParams.Loaded;
begin
     inherited Loaded;
     SetBounds(Left,Top,Width,Height);
     FEvalEdit.OnChange := FOnExpressionChange;
end;


procedure TEvalParams.CreateControls;
var i:Integer;
   function CrLabel(i:Integer):TEvalLabel;
   begin
        Result:=TEvalLabel.Create(Self);
        Result.Parent:=Self;
        Result.Name   :='ArgL'+IntToStr(i);
   end;
   function CrCombo(i:Integer):TEvalCombo;
   begin
        Result:=TEvalCombo.Create(Self);
        Result.Parent :=Self;
        Result.Name   :='Arg'+IntToStr(i);
        Result.OnChange := CBChange;
        Result.OnEnter  := CBEnter;
        // Result.Style    := csOwnerDrawFixed;
   end;
   function CrBtn(i:Integer):TSpeedButton;
   begin
        Result:=TSpeedButton.Create(Self);
        Result.Parent   :=Self;
        Result.Name     :='ArgB'+IntToStr(i);
        Result.OnClick  := BtnClick;
        Result.Hint     := rsSubFunctionHint;
        Result.Glyph.LoadFromResourceName(hInstance,'SUBFUNCTION');
   end;
begin
     //Caption:='';

     for i:=0 to MaxCtrls-1 do begin
         ArgLabel[i]:=CrLabel(i);
         ArgCombo[i]:=CrCombo(i);
         ArgBtn  [i]:=CrBtn  (i);
     end;

     FEvalEdit:=TEvalEdit.Create(Self);
     with FEvalEdit do begin
          Parent:=Self;
          FEvalEdit.OnChange := OnExpressionChange;
          //SetBounds(2,2,311,22);
          //Text  :='';
     end;
     //ArrangeControls;
end;

procedure TEvalParams.CBChange(Sender: TObject);
begin
     TComboBox(Sender).Tag:=0;
     RekalkExpr;
end;


procedure   TEvalParams.RekalkExpr;
var p,e,s: String;
    c    : TEvalCombo;
    i    : Integer;
    F    : TDefFun;
    function GetFieldNameFromCombo(C:TComboBox; P:Char):String;
    var i:Integer;
        ap:Boolean;
    begin
         Result:='';
         if C.ItemIndex<0 then Result := C.Text
         else begin
              if Eval=nil then Exit;
              i:=Integer(C.Items.Objects[C.ItemIndex]);
              if i<1000000 then begin
                  if Eval.DataSet<>nil then
                     if i<Eval.DataSet.FieldCount then Result:=Eval.DataSet.Fields[i].FieldName;
              end else begin
                  Dec(i,1000000);
                  if i<Eval.VarCount then Result:=Eval.VarNames[i];
              end;
         end;
         ap:=False;
         if (C.Tag=0) and ( C.ItemIndex<0) and (P in ['F','C','S']) and (EVal<>nil) then begin
               if (FEval.FindVariable(C.Text)<0) then
                  if (FEval.DataSet<>nil) then
                     if FEval.DataSet.FindField(C.Text)=nil then ap:=True;
         end;
         if ap then Result:=''''+Result+'''';
    end;
begin
     F:=GetFunctionBySymbol(SelectedFunction);
     p:=F.Params;
     s:=F.Name;

     if F.Kind=fnOperators then begin
        if Length(p)=1 then begin
           c  :=ArgCombo[0];
           e:=GetFieldNameFromCombo(C,P[1]);
           s:=s+' '+e;
        end else begin
             s:='';
             for i:=0 to MaxCtrls-1 do begin
                 c  :=ArgCombo[i];
                 e  :=GetFieldNameFromCombo(C,P[i+1]);

                 if e<>'' then begin
                    if s<>'' then s:=s+F.Name+' ';
                    s:=s+e;
                 end;
             end;
        end;
     end else
        for i:=1 to Length(p) do begin
            if i=1 then s:=s+'(';
            c:=ArgCombo[i-1];

            e:=GetFieldNameFromCombo(C,P[i]);
            if e='' then begin
               case p[i] of
                    'F','S','C' : e:='''''';
                    'N','R','I' : e:='0';
                    'L','B'     : e:='True';
                    'D','@'     : e:='{'+DateToStr(Date)+'}';
               end;
            end;
            s:=s+e;
            if i<>Length(p) then s:=s+','
            else                 s:=s+')';
        end;

     FEvalEdit.Text:=s;
     // if Assigned(FEvalEdit.OnChange) then FEvalEdit.OnChange(FEvalEdit);
end;

function  TEvalParams.GetExpression:String;
begin
     Result:=FEvalEdit.Text;
end;

procedure TEvalParams.SetExpression(Value:String);
begin
     FEvalEdit.Text:=Value;
end;

procedure TEvalParams.LoadFields(C:TEvalCombo);
var i:Integer;
begin
      HandleNeeded;

      if FEval=nil then Exit;
      if FEval.DataSet=nil then Exit;
      if not FEval.DataSet.Active then Exit;

      //s:=C.Text;
      C.Items.Clear;
      for i:=0 to FEval.DataSet.FieldCount-1 do begin
          case FListStyle of
            lsFieldNames : C.Items.AddObject(FEval.DataSet.Fields[i].FieldName, Pointer(i));
            lsFieldLabels: C.Items.AddObject(FEval.DataSet.Fields[i].DisplayLabel,Pointer(i));
          end;
      end;
      for i:=0 to FEval.VarCount-1 do
          C.Items.AddObject(FEval.VarNames[i],Pointer(1000000 + i));
      //C.ItemIndex := -1;
      //C.Text      := s;
end;

procedure TEvalParams.Notification(AComponent: TComponent; Operation: TOperation);
begin
     if (Operation=opRemove) then begin
        if AComponent=FEval      then Eval       := nil;
     end;

     inherited Notification(AComponent, Operation);
end;

procedure TEvalParams.SetListStyle(Value:TListStyle);
begin
     if FListStyle<>Value then begin
        FListStyle:=Value;
     end;
end;

procedure TEvalParams.SetSelectedFunction(Value:TEvalSymbol);
begin
     if FSelectedFunction<>Value then begin
        FSelectedFunction:=Value;
        InitializeCombos;
        if Assigned(FOnFunctionChange) then
           FOnFunctionChange(Self);
     end;
end;


procedure TEvalParams.InitializeCombos;
var C  : TEvalCombo;
    L  : TLabel;
    i  : Integer;
    F  : TDefFun;
    s  : String;
    function GetOneParam(var pa:String):string;
    var i:Integer;
    begin
         i:=Pos('|',pa);
         if i>0 then begin
             Result:=Copy(pa,1,i-1);
             pa    :=Copy(pa,i+1,100000);
         end else begin
             Result:=pa;
             pa:='';
         end;
    end;
begin
    F        := GetFunctionBySymbol(SelectedFunction);
    s        := F.ParHint;

    for i:=0 to 5 do begin
        C:=TEvalCombo(FindComponent('ARG'+IntToStr(i)));
        L:=TLabel(FindComponent('ARGL'+IntToStr(i)));
        if C<>nil then begin
           C.Text:='';
           C.ItemIndex:=-1;
        end;
        if L<>nil then L.Caption:=GetOneParam(s);
    end;
    RekalkExpr;
    ArrangeControls;
end;

procedure TEvalParams.BtnClick(Sender: TObject);
var C:TEvalCombo;
    s:String;
    d:Boolean;
begin
    s:=TControl(Sender).Name;
    C:=TEvalCombo(FindComponent(Copy(s,1,3)+Copy(s,5,1)));
    d:=True;

    if Assigned(FOnSubFunction) then
       FOnSubFunction(Self,C,d);

    if d then begin
      s:=DialogExpression(Level,Eval,HelpContext);
      if s<>'' then begin
        C.Text:=s;
        C.Tag:=1;
        RekalkExpr;
      end;
    end;
end;

procedure TEvalParams.SetEval(Value:TEval);
begin
     if FEval<>value then begin
        FEval:=Value;
     end;
end;

procedure TEvalParams.SetBounds(ALeft, ATop, AWidth, AHeight: Integer);
begin
     inherited SetBounds(ALeft, ATop, AWidth, AHeight);
     ArrangeControls;
end;

procedure   TEvalParams.ArrangeControls;
var i,dx,dy,le : Integer;
begin
     if csLoading in ComponentState then Exit;
     if FEvalEdit = nil then Exit;

        dy:=FDistance;
        le:=ParamCount;
        if FEvalEdit.Visible then begin
           FEvalEdit.SetBounds(FDistance,dy,Width-2*FDistance,FEvalEdit.Height);
           Inc(dy,FEvalEdit.Height+3);
        end;
        for i:=0 to MaxCtrls-1 do begin
            dx:=FDistance;
            if FLabelsVisible then begin
              ArgLabel[i].SetBounds(dx,dy,width div 3,ArgLabel[i].Height);
              Inc(dx,width div 3);
            end;
            if FSubBtnVisible then begin
              ArgBtn  [i].SetBounds(dx,dy,20, 20);
              Inc(dx,20);
            end;
            ArgCombo[i].SetBounds(dx,dy,Width-FDistance-dx,ArgCombo[i].Height);

            ArgBtn  [i].Visible := FSubBtnVisible and (i<le);
            ArgLabel[i].Visible := FLabelsVisible and (i<le);
            ArgCombo[i].Visible := (i<le);

            Inc(dy, ArgCombo[i].Height);
        end;
end;

procedure TEvalParams.SetSubBtnVisible(Value:Boolean);
begin
     if Value<>FSubBtnVisible then begin
        FSubBtnVisible:=Value;
        ArrangeControls;
     end;
end;

procedure TEvalParams.SetLabelsVisible(Value:Boolean);
begin
     if Value<>FLabelsVisible then begin
        FLabelsVisible:=Value;
        ArrangeControls;
     end;
end;

procedure TEvalParams.SetDistance(Value:Integer);
begin
     if FDistance<>Value then begin
        FDistance:=Value;
        ArrangeControls;
     end;
end;

function TEvalParams.ParamCount:Integer;
begin
    Result   := Length(GetFunctionBySymbol(SelectedFunction).Params);
end;

procedure   TEvalParams.CBEnter(Sender:TObject);
begin
     LoadFields(TEvalCombo(Sender));
end;


end.
