unit EvalNav;

interface
uses DBCtrls,Classes,Eval;

type
  TEvalDBNavigator = class(TDBNavigator)
  private
       FFiltered                            : Boolean;
       FEvalComp                            : TEval;
       FOldClickHandler                     : TNotifyEvent;
       FOnDelete                            : TNotifyEvent;
       procedure SetFiltered(Value:Boolean);
       procedure SetEval(Value:TEval);
  protected
       procedure EvalClickHandler(Sender: TObject);
  public
      constructor Create(Aowner:TComponent); override;
  published
       property EvalComp  : TEval    Read FEvalComp  Write SetEval;
       property Filtered : Boolean   Read FFiltered  Write SetFiltered;
       property OnDelete : TNotifyEvent Read FOnDelete Write FOnDelete;
 end;

 // TEvalEnhDBNavigator=class(TPanel)
 // end;
 //

implementation

{uses TypInfo,DB;}

constructor TEvalDBNavigator.Create(Aowner:TComponent);
var i:TNavigateBtn;
begin
     inherited Create(AOwner);
     FFiltered := True;
     for i:=Low(Buttons) to High(Buttons) do begin
         FOldClickHandler  := Buttons[i].OnClick;
         Buttons[i].OnClick:= EvalClickHandler;
     end;
end;

procedure TEvalDBNavigator.SetFiltered(Value:Boolean);
begin
        FFiltered:=Value;
end;

procedure TEvalDBNavigator.EvalClickHandler(Sender:TObject);
{var S : TDataSet;
    P : PPropInfo;}
begin
     {S:=DataSource.DataSet;
     if S<>nil then begin
        P:=GetPropInfo(S.ClassInfo,'Eval');
        if P<>nil then begin
           FEvalComp := TEval(GetOrdProp(S,P));
           Filtered  := True;
        end;
     end;
     }

     if (Sender=Buttons[nbDelete]) and Assigned(FOnDelete) then
        FOnDelete(Self);

     if Filtered and (EValComp<>nil) and (EValComp.Expression<>'') then
      case TNavButton(Sender).Index of
        nbPrior : EvalComp.Prior;
        nbNext  : EvalComp.Next;
        nbFirst : EvalComp.First;
        nbLast  : EvalComp.Last;
        else      FOldClickHandler(Sender);
     end else
        FOldClickHandler(Sender);
end;

procedure TEvalDBNavigator.SetEval(Value:TEval);
begin
     FEvalComp:=Value;
end;

end.
