unit EvalDefs;

interface
uses Classes,SysUtils;
type

  TFnType  = (fnNone,fnAll,fnOperators,fnString,fnNumber,fnDate,fnGonio,
              fnFinancial,fnConversion,fnFile,fnMisc);

  TFnTypes = set of TFnType;

  TEvalHtml = (fnEvalHtmlTable, fnEvalHtmlTableWithCall,
               fnEvalHtmlList,fnEvalHtmlText);

  TEvalSymbol = ( esNone,esEOF,esCONST,esVAR_ID,esTABLE_ID,esCOLON,esCOMMA,
                  esLZ,esPZ,esPLUS,esMINUS,esUN_MINUS,esMULTIPLY,esDIVISION,
                  esAND,esOR,esXOR,esNOT,esAbove,esLess,esAboveEqual,
                  esLessEqual,esEqual,esNotEqual,esMOD,esDIV,
                  esSTRING,esINTEGER,esBoolean,esReal,

    // string functions
    esContain,esAnsiCompareStr,esAnsiCompareText,esConcat,esCopy,esDelete,esInsert,esReplace,
    esLength,esPos,esStringOfChar,
    esLowerCase,esUpperCase,esAnsiLowerCase,esAnsiUpperCase,
    esTrim,esTrimLeft,esTrimRight,
    esPosWithError,esStringAnywhere,esAnsiStringAnywhere,esCompareStr,esCompareText,esQuotedStr,
    esAnsiQuotedStr,esAnsiExtractQuotedStr,
    esAnsiPos,esBefore,esAfter,esLeft,esRight,
    esChr, esOrd,esDelChars,esCenter,esMatchStrings,
    esWordCount,esGetWord,esCapFirst,esSoundLike,

    // date functions
    esDate,esDayOfWeek,esEncodeDate,esEncodeTime,esFormatDateTime,
    esYear, esMonth, esDay, esWeek, esCentury,
    esMonthName, esMonthNameLong,
    esDayName,   esDayNameLong,
    esTime,esNow,esIncMonth,esIncDays,esIsLeapYear,esDaysInMonth,esDaysBetween,
    esHour,esMinute,esSecond,

    // file functions
    esChangeFileExt,esExpandFileName,
    esExtractFileDir,esExtractFileExt,esExtractFileName,esExtractFilePath,
    esExtractFileDrive,esExpandUNCFileName,esExtractRelativePath,
    esFileAge,esFileExists,esFileSize,
    esFileSearch,esDiskFree,esDiskSize,
    esAnsiCompareFileName,esAnsiLowerCaseFileName,esAnsiUpperCaseFileName,


    // numeric
    esAbs,esFrac,esTrunc,esRound,esHi,esInt,esLn,esLo,esOdd,esRandom,esSqr,esSqrt,
    esMin,esMax,esExp,esPI,
    esLNXP1,esLog10,esLog2,esLogN,
    esIntPower,esPower,
    esMantissa,esExponent, // tieto dve funkcie budu vyuzivat frexp funkciu
    esLDExp,esCeil,esFloor,
    esSign,esFaktorial,esPermutation,

    // goniometric
    esSin,esCos,esTan,esCoTan,esArcSin,esArcCos,esArcTan,esArcTan2,esHypot,
    esDegToRad,esRadToDeg,esGradToRad,esRadToGrad,esCycleToRad,esRadToCycle,
    esCosh,esSinh,esTanH,esArcCosh,esArcSinh,esArcTanH,
    esCircleO,esCircleP,

    // conversion
    esNumberToSpell,esDateTimeToStr,esDateTimeToString,esDateToStr,
    esFloatToStr,esCurrToStr,esFormatFloat,esIntToHex,
    esStrToDate,esStrToDateTime,esStrToFloat,esStrToCurr,esStrToInt,esStrToTime,
    esIntToStr,esFloatToDecimal,esFloatToStrF,esCurrToStrF,esFormatCurr,
    esTimeToStr,esDecToRoman,

    // miscelanous
    esCond,esBetween,esBetweenStrings,esSysErrorMessage,esGetLocaleStr,

    // financial functions
    esDoubleDecliningBalance,esFutureValue, esInterestPayment,
    esInterestRate, //esInternalRateOfReturn
    esNumberOfPeriods,esNetPresentValue,esPayment,
    esPeriodPayment,esPresentValue,esSLNDepreciation,
    esSYDDepreciation


    // here is place for custom functions


    // esPoly, esMean, esSum, esSumOfSquares, esMinValue, esMaxValue
    // esStDev, esPopnStdDev, esMeanAndStdDev
    // esVariance, esPopnVariance, esTotalVariance,esNorm
    // esRandG

  );


  ParamString = string[10];

  TDefFun = Record
      ID      : word;           // 0-basic 1-advanced 2-expert
      Name    : String;         // function name
      Params  : ParamString;    // parameters
      Kind    : TFnType;        // group
      FT      : TEvalSymbol;    // function id
      Hint    : String;
      ParHint : String;
      // Call    : Pointer;
  End;

  //TFunctions = class(TStringList)
  //public
  //      procedure AddFunction(Name,Hint,ParHit,Params:String; Kind:TFnType; Call:Pointer);
  //end;

  EFunArrayError = class(Exception);

  function  GetFunctionByIndex(idx:Integer):TDefFun;
  function  GetFunctionByName(Name:String):TDefFun;
  function  GetFunctionBySymbol(fn:TEvalSymbol):TDefFun;

  function  GetFunctionCount:Integer;
  procedure GetFunctionList(L:TStrings);
  function  GetFnCall(idx:Integer):String;
  procedure GetFunctionNames(fn:TFnTypes; L:TStrings);
  procedure GetFunctionGroup(L:TStrings);
  function  GetFunctionGroupName(T:TFnType):String;
  procedure CreateFunctionHTML(FileName:String; Style : TEvalHtml);

implementation

uses Dialogs,EvalRes,EvalFn;

Const
     FunctionGroup : Array[TFnType] of String = (
     '' ,     rsGroupAll,
     rsGroupOperators,rsGroupString   ,rsGroupNumber   ,rsGroupdate     ,
     rsGroupGonio    ,rsGroupFinancial,rsGroupConversion,rsGroupFile     ,
     rsGroupMisc);


     // if you add custom function, don't forget increase size DefFun to [1..191]
     DefFun        : Array [1..190] of TDefFun=(
     //esPLUS,esMINUS,esUN_MINUS,esMULTIPLY,esDIVISION,
     //esV,esVR,esM,esMR,esR,esNR,esAND,esOR,esXOR,esNOT,
     //esMOD,esDIV,
     (ID:0 ; Name:'+'                   ;Params:'RRRRRR'; Kind:fnOperators;   FT:esPlus                             ;Hint:rsHint_Plus                         ;ParHint:rsConst6Arg ),
     (ID:0 ; Name:'-'                   ;Params:'RRRRRR'; Kind:fnOperators;   FT:esMinus                            ;Hint:rsHint_Minus                        ;ParHint:rsConst6Arg ),
     (ID:0 ; Name:'*'                   ;Params:'RRRRRR'; Kind:fnOperators;   FT:esMultiply                         ;Hint:rsHint_Multiply                     ;ParHint:rsConst6Arg ),
     (ID:0 ; Name:'/'                   ;Params:'RRRRRR'; Kind:fnOperators;   FT:esDivision                         ;Hint:rsHint_Division                     ;ParHint:rsConst6Arg ),
     (ID:0 ; Name:'and'                 ;Params:'RRRRRR'; Kind:fnOperators;   FT:esAnd                              ;Hint:rsHint_And                          ;ParHint:rsConst6Arg ),
     (ID:0 ; Name:'or'                  ;Params:'RRRRRR'; Kind:fnOperators;   FT:esOr                               ;Hint:rsHint_Or                           ;ParHint:rsConst6Arg ),
     (ID:0 ; Name:'xor'                 ;Params:'RR'    ; Kind:fnOperators;   FT:esXOR                              ;Hint:rsHint_XOR                          ;ParHint:rsConst2Arg ),
     (ID:0 ; Name:'>'                   ;Params:'RR'   ; Kind:fnOperators;   FT:esAbove                            ;Hint:rsHint_Above                        ;ParHint:rsConst2Arg ),
     (ID:0 ; Name:'>='                  ;Params:'RR'   ; Kind:fnOperators;   FT:esAboveEqual                       ;Hint:rsHint_AboveEqual                   ;ParHint:rsConst2Arg ),
     (ID:0 ; Name:'<'                   ;Params:'RR'   ; Kind:fnOperators;   FT:esLess                             ;Hint:rsHint_Less                         ;ParHint:rsConst2Arg ),
     (ID:0 ; Name:'<='                  ;Params:'RR'   ; Kind:fnOperators;   FT:esLessEqual                        ;Hint:rsHint_LessEqual                    ;ParHint:rsConst2Arg ),
     (ID:0 ; Name:'='                   ;Params:'RR'   ; Kind:fnOperators;   FT:esEqual                            ;Hint:rsHint_Equal                        ;ParHint:rsConst2Arg ),
     (ID:0 ; Name:'<>'                  ;Params:'RR'   ; Kind:fnOperators;   FT:esNotEqual                         ;Hint:rsHint_NotEqual                     ;ParHint:rsConst2Arg ),
     (ID:0 ; Name:'Between'    ;         Params:'RRR' ;Kind:fnMisc;         FT:esBetween                           ;Hint:rsHint_Between                      ;ParHint:rsPar_Between              ),
     (ID:0 ; Name:'BetweenStrings' ;     Params:'SSS' ;Kind:fnMisc;         FT:esBetweenStrings                    ;Hint:rsHint_BetweenStrings               ;ParHint:rsPar_BetweenStrings       ),
     (ID:0 ; Name:'not'                 ;Params:'L'    ; Kind:fnOperators;   FT:esNOT                              ;Hint:rsHint_Not                          ;ParHint:''),
     (ID:0 ; Name:'mod'                 ;Params:'RR'   ; Kind:fnOperators;   FT:esMOD                              ;Hint:rsHint_MOD                          ;ParHint:rsConst2Arg),
     (ID:0 ; Name:'div'                 ;Params:'RR'   ; Kind:fnOperators;   FT:esDIV                              ;Hint:rsHint_DIV                          ;ParHint:rsConst2Arg),

     (ID:0 ; Name:'Contain'             ;Params:'SS'   ; Kind:fnString;      FT:esContain                          ;Hint:rsHint_Contain                 ;ParHint:rsPar_Pos                  ),
     (ID:0 ; Name:'AnsiCompareStr'      ;Params:'SS'   ; Kind:fnString;      FT:esAnsiCompareStr                   ;Hint:rsHint_AnsiCompareStr          ;ParHint:rsPar_AnsiCompareStr       ),
     (ID:0 ; Name:'AnsiCompareText'     ;Params:'SS'   ; Kind:fnString;      FT:esAnsiCompareText                  ;Hint:rsHint_AnsiCompareText         ;ParHint:rsPar_AnsiCompareText      ),
     (ID:0 ; Name:'Concat'              ;Params:'SSS'  ; Kind:fnString;      FT:esConcat                           ;Hint:rsHint_Concat                  ;ParHint:rsPar_Concat               ),
     (ID:0 ; Name:'Copy'                ;Params:'SII'  ; Kind:fnString;      FT:esCopy                             ;Hint:rsHint_Copy                    ;ParHint:rsPar_Copy                 ),
     (ID:0 ; Name:'Delete'              ;Params:'SII'  ; Kind:fnString;      FT:esDelete                           ;Hint:rsHint_Delete                  ;ParHint:rsPar_Delete               ),
     (ID:0 ; Name:'Insert'              ;Params:'SSI'  ; Kind:fnString;      FT:esInsert                           ;Hint:rsHint_Insert                  ;ParHint:rsPar_Insert               ),
     (ID:0 ; Name:'Replace'             ;Params:'SSS'  ; Kind:fnString;      FT:esReplace                          ;Hint:rsHint_Replace                 ;ParHint:rsPar_Replace              ),
     (ID:0 ; Name:'Length'              ;Params:'S'    ; Kind:fnString;      FT:esLength                           ;Hint:rsHint_Length                  ;ParHint:rsPar_Length               ),
     (ID:0 ; Name:'Pos'                 ;Params:'SS'   ; Kind:fnString;      FT:esPos                              ;Hint:rsHint_Pos                     ;ParHint:rsPar_Pos                  ),
     (ID:0 ; Name:'StringOfChar'        ;Params:'SI'   ; Kind:fnString;      FT:esStringOfChar                     ;Hint:rsHint_StringOfChar            ;ParHint:rsPar_StringOfChar         ),
     (ID:0 ; Name:'LowerCase'           ;Params:'S'    ; Kind:fnString;      FT:esLowerCase                        ;Hint:rsHint_LowerCase               ;ParHint:rsPar_LowerCase            ),
     (ID:0 ; Name:'UpperCase'           ;Params:'S'    ; Kind:fnString;      FT:esUpperCase                        ;Hint:rsHint_UpperCase               ;ParHint:rsPar_UpperCase            ),
     (ID:0 ; Name:'AnsiLowerCase'       ;Params:'S'    ; Kind:fnString;      FT:esAnsiLowerCase                    ;Hint:rsHint_AnsiLowerCase           ;ParHint:rsPar_AnsiLowerCase        ),
     (ID:0 ; Name:'AnsiUpperCase'       ;Params:'S'    ; Kind:fnString;      FT:esAnsiUpperCase                    ;Hint:rsHint_AnsiUpperCase           ;ParHint:rsPar_AnsiUpperCase        ),
     (ID:0 ; Name:'Trim'                ;Params:'S'    ; Kind:fnString;      FT:estrim                             ;Hint:rsHint_trim                    ;ParHint:rsPar_trim                 ),
     (ID:0 ; Name:'trimleft'            ;Params:'S'    ; Kind:fnString;      FT:estrimleft                         ;Hint:rsHint_trimleft                ;ParHint:rsPar_trimleft             ),
     (ID:0 ; Name:'TrimRight'           ;Params:'S'    ; Kind:fnString;      FT:esTrimRight                        ;Hint:rsHint_TrimRight               ;ParHint:rsPar_TrimRight            ),
     (ID:1 ; Name:'PosWithError'        ;Params:'SSI'  ; Kind:fnString;      FT:esPosWithError                     ;Hint:rsHint_PosWithError            ;ParHint:rsPar_PosWithError         ),
     (ID:1 ; Name:'StringAnywhere'      ;Params:'S'    ; Kind:fnString;      FT:esStringAnywhere                   ;Hint:rsHint_StringAnywhere          ;ParHint:rsPar_StringAnywhere       ),
     (ID:1 ; Name:'AnsiStringAnywhere'  ;Params:'S'    ; Kind:fnString;      FT:esAnsiStringAnywhere               ;Hint:rsHint_AnsiStringAnywhere      ;ParHint:rsPar_AnsiStringAnywhere   ),
     (ID:0 ; Name:'CompareStr'          ;Params:'SS'   ; Kind:fnString;      FT:esCompareStr                       ;Hint:rsHint_CompareStr              ;ParHint:rsPar_CompareStr           ),
     (ID:0 ; Name:'CompareText'         ;Params:'SS'   ; Kind:fnString;      FT:esCompareText                      ;Hint:rsHint_CompareText             ;ParHint:rsPar_CompareText          ),
     (ID:1 ; Name:'QuotedStr'           ;Params:'S'    ; Kind:fnString;      FT:esQuotedStr                        ;Hint:rsHint_QuotedStr               ;ParHint:rsPar_QuotedStr            ),
     (ID:1 ; Name:'AnsiQuotedStr'       ;Params:'SS'   ; Kind:fnString;      FT:esAnsiQuotedStr                    ;Hint:rsHint_AnsiQuotedStr           ;ParHint:rsPar_AnsiQuotedStr        ),
     (ID:1 ; Name:'AnsiExtractQuotedStr';Params:'SS'   ; Kind:fnString;      FT:esAnsiExtractQuotedStr             ;Hint:rsHint_AnsiExtractQuotedStr    ;ParHint:rsPar_AnsiExtractQuotedStr ),
     (ID:0 ; Name:'AnsiPos'             ;Params:'SS'   ; Kind:fnString;      FT:esAnsiPos                          ;Hint:rsHint_AnsiPos                 ;ParHint:rsPar_AnsiPos              ),
     (ID:0 ; Name:'Before'              ;Params:'SS'   ; Kind:fnString;      FT:esBefore                           ;Hint:rsHint_Before                  ;ParHint:rsPar_Before               ),
     (ID:0 ; Name:'After'               ;Params:'SS'   ; Kind:fnString;      FT:esAfter                            ;Hint:rsHint_After                   ;ParHint:rsPar_After                ),
     (ID:0 ; Name:'StringLeft'          ;Params:'SI'   ; Kind:fnString;      FT:esLeft                             ;Hint:rsHint_Left                    ;ParHint:rsPar_Left                 ),
     (ID:0 ; Name:'StringRight'         ;Params:'SI'   ; Kind:fnString;      FT:esRight                            ;Hint:rsHint_Right                   ;ParHint:rsPar_Right                ),
     (ID:0 ; Name:'Chr'                 ;Params:'I'    ; Kind:fnString;      FT:esChr                              ;Hint:rsHint_Chr                     ;ParHint:rsPar_Chr                  ),
     (ID:0 ; Name:'Ord'                 ;Params:'S'    ; Kind:fnString;      FT:esOrd                              ;Hint:rsHint_Ord                     ;ParHint:rsPar_Ord                  ),
     (ID:0 ; Name:'DelChars'            ;Params:'SS'   ; Kind:fnString;      FT:esDelChars                         ;Hint:rsHint_DelChars                ;ParHint:rsPar_DelChars             ),
     (ID:0 ; Name:'Center'              ;Params:'SIS'  ; Kind:fnString;      FT:esCenter                           ;Hint:rsHint_Center                  ;ParHint:rsPar_Center               ),
     (ID:1 ; Name:'MatchStrings'        ;Params:'SS'   ; Kind:fnString;      FT:esMatchStrings                     ;Hint:rsHint_MatchStrings            ;ParHint:rsPar_MatchStrings         ),
     (ID:1 ; Name:'WordCount'           ;Params:'S'    ; Kind:fnString;      FT:esWordCount                        ;Hint:rsHint_WordCount               ;ParHint:rsPar_WordCount            ),
     (ID:1 ; Name:'GetWord'             ;Params:'SI'   ; Kind:fnString;      FT:esGetWord                          ;Hint:rsHint_GetWord                 ;ParHint:rsPar_GetWord              ),
     (ID:1 ; Name:'CapitalizeFirstLetter';Params:'S'   ; Kind:fnString;      FT:esCapFirst                         ;Hint:rsHint_CapFirst                ;ParHint:rsPar_CapFirst             ),
     (ID:2 ; Name:'SoundLike'            ;Params:'SS'  ; Kind:fnString;      FT:esSoundLike                        ;Hint:rsHint_SoundLike               ;ParHint:rsPar_SoundLike            ),
     //esCurrencyToString

     // date & time functions
     (ID:0 ; Name:'Date'                ;Params:''     ;Kind:fndate;         FT:esDate                             ;Hint:rsHint_Date                    ;ParHint:rsPar_Date                 ),
     (ID:0 ; Name:'DayOfWeek'           ;Params:'@'    ;Kind:fndate;         FT:esDayOfWeek                        ;Hint:rsHint_DayOfWeek               ;ParHint:rsPar_DayOfWeek            ),
     (ID:0 ; Name:'EncodeDate'          ;Params:'III'  ;Kind:fndate;         FT:esEncodeDate                       ;Hint:rsHint_EncodeDate              ;ParHint:rsPar_EncodeDate           ),
     (ID:0 ; Name:'EncodeTime'          ;Params:'IIII' ;Kind:fndate;         FT:esEncodeTime                       ;Hint:rsHint_EncodeTime              ;ParHint:rsPar_EncodeTime           ),
     (ID:0 ; Name:'FormatDateTime'      ;Params:'S@'   ;Kind:fndate;         FT:esFormatDateTime                   ;Hint:rsHint_FormatDateTime          ;ParHint:rsPar_FormatDateTime       ),
     (ID:0 ; Name:'Year'                ;Params:'@'    ;Kind:fndate;         FT:esYear                             ;Hint:rsHint_Year                    ;ParHint:rsPar_Year                 ),
     (ID:0 ; Name:'Month'               ;Params:'@'    ;Kind:fndate;         FT:esMonth                            ;Hint:rsHint_Month                   ;ParHint:rsPar_Month                ),
     (ID:0 ; Name:'Day'                 ;Params:'@'    ;Kind:fndate;         FT:esDay                              ;Hint:rsHint_Day                     ;ParHint:rsPar_Day                  ),
     (ID:0 ; Name:'Week'                ;Params:'@'    ;Kind:fndate;         FT:esWeek                             ;Hint:rsHint_Week                    ;ParHint:rsPar_Week                 ),
     (ID:0 ; Name:'Century'             ;Params:'@'    ;Kind:fndate;         FT:esCentury                          ;Hint:rsHint_Century                 ;ParHint:rsPar_Century              ),
     (ID:0 ; Name:'MonthName'           ;Params:'@'    ;Kind:fndate;         FT:esMonthName                        ;Hint:rsHint_MonthName               ;ParHint:rsPar_MonthName            ),
     (ID:0 ; Name:'MonthNameLong'       ;Params:'@'    ;Kind:fndate;         FT:esMonthNameLong                    ;Hint:rsHint_MonthNameLong           ;ParHint:rsPar_MonthNameLong        ),
     (ID:0 ; Name:'DayName'             ;Params:'@'    ;Kind:fndate;         FT:esDayName                          ;Hint:rsHint_DayName                 ;ParHint:rsPar_DayName              ),
     (ID:0 ; Name:'DayNameLong'         ;Params:'@'    ;Kind:fndate;         FT:esDayNameLong                      ;Hint:rsHint_DayNameLong             ;ParHint:rsPar_DayNameLong          ),
     (ID:0 ; Name:'Time'                ;Params:''     ;Kind:fndate;         FT:esTime                             ;Hint:rsHint_Time                    ;ParHint:rsPar_Time                 ),
     (ID:0 ; Name:'Now'                 ;Params:''     ;Kind:fndate;         FT:esNow                              ;Hint:rsHint_Now                     ;ParHint:rsPar_Now                  ),
     (ID:0 ; Name:'IncMonth'            ;Params:'@I'   ;Kind:fndate;         FT:esIncMonth                         ;Hint:rsHint_IncMonth                ;ParHint:rsPar_IncMonth             ),
     (ID:0 ; Name:'IncDays'             ;Params:'@I'   ;Kind:fndate;         FT:esIncDays                          ;Hint:rsHint_IncDays                 ;ParHint:rsPar_IncDays              ),
     (ID:0 ; Name:'IsLeapYear'          ;Params:'@'    ;Kind:fndate;         FT:esIsLeapYear                       ;Hint:rsHint_IsLeapYear              ;ParHint:rsPar_IsLeapYear           ),
     (ID:0 ; Name:'DaysInMonth'         ;Params:'@'    ;Kind:fndate;         FT:esDaysInMonth                      ;Hint:rsHint_DaysInMonth             ;ParHint:rsPar_DaysInMonth          ),
     (ID:0 ; Name:'DaysBetween'         ;Params:'@@'   ;Kind:fndate;         FT:esDaysBetween                      ;Hint:rsHint_DaysBetween             ;ParHint:rsPar_DaysBetween          ),
     (ID:0 ; Name:'Hour'                ;Params:'@'    ;Kind:fndate;         FT:esHour                             ;Hint:rsHint_Hour                    ;ParHint:rsPar_Hour                 ),
     (ID:0 ; Name:'Minute'              ;Params:'@'    ;Kind:fndate;         FT:esMinute                           ;Hint:rsHint_Minute                  ;ParHint:rsPar_Minute               ),
     (ID:0 ; Name:'Second'              ;Params:'@'    ;Kind:fndate;         FT:esSecond                           ;Hint:rsHint_Second                  ;ParHint:rsPar_Second               ),

     // file functions
     (ID:1 ; Name:'ChangeFileExt'       ;Params:'FS'   ;Kind:fnFile;         FT:esChangeFileExt                    ;Hint:rsHint_ChangeFileExt           ;ParHint:rsPar_ChangeFileExt        ),
     (ID:1 ; Name:'ExpandFileName'      ;Params:'F'    ;Kind:fnFile;         FT:esExpandFileName                   ;Hint:rsHint_ExpandFileName          ;ParHint:rsPar_ExpandFileName       ),
     (ID:1 ; Name:'ExtractFileDir'      ;Params:'F'    ;Kind:fnFile;         FT:esExtractFileDir                   ;Hint:rsHint_ExtractFileDir          ;ParHint:rsPar_ExtractFileDir       ),
     (ID:1 ; Name:'ExtractFileExt'      ;Params:'F'    ;Kind:fnFile;         FT:esExtractFileExt                   ;Hint:rsHint_ExtractFileExt          ;ParHint:rsPar_ExtractFileExt       ),
     (ID:1 ; Name:'ExtractFileName'     ;Params:'F'    ;Kind:fnFile;         FT:esExtractFileName                  ;Hint:rsHint_ExtractFileName         ;ParHint:rsPar_ExtractFileName      ),
     (ID:1 ; Name:'ExtractFilePath'     ;Params:'F'    ;Kind:fnFile;         FT:esExtractFilePath                  ;Hint:rsHint_ExtractFilePath         ;ParHint:rsPar_ExtractFilePath      ),
     (ID:1 ; Name:'ExtractFileDrive'    ;Params:'F'    ;Kind:fnFile;         FT:esExtractFileDrive                 ;Hint:rsHint_ExtractFileDrive        ;ParHint:rsPar_ExtractFileDrive     ),
     (ID:1 ; Name:'ExpandUNCFileName'   ;Params:'F'    ;Kind:fnFile;         FT:esExpandUNCFileName                ;Hint:rsHint_ExpandUNCFileName       ;ParHint:rsPar_ExpandUNCFileName    ),
     (ID:1 ; Name:'ExtractRelativePath' ;Params:'FF'   ;Kind:fnFile;         FT:esExtractRelativePath              ;Hint:rsHint_ExtractRelativePath     ;ParHint:rsPar_ExtractRelativePath  ),
     (ID:1 ; Name:'FileAge'             ;Params:'F'    ;Kind:fnFile;         FT:esFileAge                          ;Hint:rsHint_FileAge                 ;ParHint:rsPar_FileAge              ),
     (ID:1 ; Name:'FileExists'          ;Params:'F'    ;Kind:fnFile;         FT:esFileExists                       ;Hint:rsHint_FileExists              ;ParHint:rsPar_FileExists           ),
     (ID:1 ; Name:'GetFileSize'         ;Params:'F'    ;Kind:fnFile;         FT:esFileSize                         ;Hint:rsHint_FileSize                ;ParHint:rsPar_FileSize             ),
     (ID:1 ; Name:'FileSearch'          ;Params:'SS'   ;Kind:fnFile;         FT:esFileSearch                       ;Hint:rsHint_FileSearch              ;ParHint:rsPar_FileSearch           ),
     (ID:1 ; Name:'DiskFree'            ;Params:'I'    ;Kind:fnFile;         FT:esDiskFree                         ;Hint:rsHint_DiskFree                ;ParHint:rsPar_DiskFree             ),
     (ID:1 ; Name:'DiskSize'            ;Params:'I'    ;Kind:fnFile;         FT:esDiskSize                         ;Hint:rsHint_DiskSize                ;ParHint:rsPar_DiskSize             ),
     (ID:1 ; Name:'AnsiCompareFileName' ;Params:'SS'   ;Kind:fnFile;         FT:esAnsiCompareFileName              ;Hint:rsHint_AnsiCompareFileName     ;ParHint:rsPar_AnsiCompareFileName  ),
     (ID:1 ; Name:'AnsiLowerCaseFileName';Params:'F'   ;Kind:fnFile;         FT:esAnsiLowerCaseFileName            ;Hint:rsHint_AnsiLowerCaseFileName   ;ParHint:rsPar_AnsiLowerCaseFileName),
     (ID:1 ; Name:'AnsiUpperCaseFileName';Params:'F'   ;Kind:fnFile;         FT:esAnsiUpperCaseFileName            ;Hint:rsHint_AnsiUpperCaseFileName   ;ParHint:rsPar_AnsiUpperCaseFileName),

     // numeric
     (ID:0 ; Name:'Abs';                  Params:'R';   Kind:fnNumber;       FT:esAbs                              ;Hint:rsHint_Abs                     ;ParHint:rsPar_Abs                  ),
     (ID:0 ; Name:'Frac';                 Params:'R';   Kind:fnNumber;       FT:esFrac                             ;Hint:rsHint_Frac                    ;ParHint:rsPar_Frac                 ),
     (ID:0 ; Name:'Trunc';                Params:'R';   Kind:fnNumber;       FT:esTrunc                            ;Hint:rsHint_Trunc                   ;ParHint:rsPar_Trunc                ),
     (ID:0 ; Name:'Round';                Params:'R';   Kind:fnNumber;       FT:esRound                            ;Hint:rsHint_Round                   ;ParHint:rsPar_Round                ),
     (ID:0 ; Name:'Hi';                   Params:'R';   Kind:fnNumber;       FT:esHi                               ;Hint:rsHint_Hi                      ;ParHint:rsPar_Hi                   ),
     (ID:0 ; Name:'Int';                  Params:'R';   Kind:fnNumber;       FT:esInt                              ;Hint:rsHint_Int                     ;ParHint:rsPar_Int                  ),
     (ID:0 ; Name:'Ln';                   Params:'R';   Kind:fnNumber;       FT:esLn                               ;Hint:rsHint_Ln                      ;ParHint:rsPar_Ln                   ),
     (ID:0 ; Name:'Lo';                   Params:'R';   Kind:fnNumber;       FT:esLo                               ;Hint:rsHint_Lo                      ;ParHint:rsPar_Lo                   ),
     (ID:0 ; Name:'Odd';                  Params:'R';   Kind:fnNumber;       FT:esOdd                              ;Hint:rsHint_Odd                     ;ParHint:rsPar_Odd                  ),
     (ID:0 ; Name:'Random';               Params:'R';   Kind:fnNumber;       FT:esRandom                           ;Hint:rsHint_Random                  ;ParHint:rsPar_Random               ),
     (ID:0 ; Name:'Sqr';                  Params:'R';   Kind:fnNumber;       FT:esSqr                              ;Hint:rsHint_Sqr                     ;ParHint:rsPar_Sqr                  ),
     (ID:0 ; Name:'Sqrt';                 Params:'R';   Kind:fnNumber;       FT:esSqrt                             ;Hint:rsHint_Sqrt                    ;ParHint:rsPar_Sqrt                 ),
     (ID:0 ; Name:'Min';                  Params:'RR';  Kind:fnNumber;       FT:esMin                              ;Hint:rsHint_Min                     ;ParHint:rsPar_Min                  ),
     (ID:0 ; Name:'Max';                  Params:'RR';  Kind:fnNumber;       FT:esMax                              ;Hint:rsHint_Max                     ;ParHint:rsPar_Max                  ),
     (ID:0 ; Name:'Exp';                  Params:'R';   Kind:fnNumber;       FT:esExp                              ;Hint:rsHint_Exp                     ;ParHint:rsPar_Exp                  ),
     (ID:0 ; Name:'PI';                   Params:'';    Kind:fnNumber;       FT:esPI                               ;Hint:rsHint_PI                      ;ParHint:rsPar_PI                   ),
     (ID:0 ; Name:'LNPX1';                Params:'R';   Kind:fnNumber;       FT:esLNXP1                            ;Hint:rsHint_LNXP1                   ;ParHint:rsPar_LNXP1                ),
     (ID:0 ; Name:'Log10';                Params:'R';   Kind:fnNumber;       FT:esLog10                            ;Hint:rsHint_Log10                   ;ParHint:rsPar_Log10                ),
     (ID:0 ; Name:'Log2';                 Params:'R';   Kind:fnNumber;       FT:esLog2                             ;Hint:rsHint_Log2                    ;ParHint:rsPar_Log2                 ),
     (ID:0 ; Name:'LogN';                 Params:'RR';  Kind:fnNumber;       FT:esLogN                             ;Hint:rsHint_LogN                    ;ParHint:rsPar_LogN                 ),
     (ID:0 ; Name:'IntPower';             Params:'RI';  Kind:fnNumber;       FT:esIntPower                         ;Hint:rsHint_IntPower                ;ParHint:rsPar_IntPower             ),
     (ID:0 ; Name:'Power';                Params:'RR';  Kind:fnNumber;       FT:esPower                            ;Hint:rsHint_Power                   ;ParHint:rsPar_Power                ),
     (ID:0 ; Name:'Mantissa';             Params:'R';   Kind:fnNumber;       FT:esMantissa                         ;Hint:rsHint_Mantissa                ;ParHint:rsPar_Mantissa             ),
     (ID:0 ; Name:'Exponent';             Params:'R';   Kind:fnNumber;       FT:esExponent                         ;Hint:rsHint_Exponent                ;ParHint:rsPar_Exponent             ),
     (ID:0 ; Name:'LDExp';                Params:'RI';  Kind:fnNumber;       FT:esLDExp                            ;Hint:rsHint_LDExp                   ;ParHint:rsPar_LDExp                ),
     (ID:0 ; Name:'Ceil';                 Params:'R';   Kind:fnNumber;       FT:esCeil                             ;Hint:rsHint_Ceil                    ;ParHint:rsPar_Ceil                 ),
     (ID:0 ; Name:'Floor';                Params:'R';   Kind:fnNumber;       FT:esFloor                            ;Hint:rsHint_Floor                   ;ParHint:rsPar_Floor                ),
     (ID:0 ; Name:'Sign';                 Params:'R';   Kind:fnNumber;       FT:esSign                             ;Hint:rsHint_Sign                    ;ParHint:rsPar_Sign                 ),
     (ID:0 ; Name:'Faktorial';            Params:'I';   Kind:fnNumber;       FT:esFaktorial                        ;Hint:rsHint_Faktorial               ;ParHint:rsPar_Faktorial            ),
     (ID:0 ; Name:'Permutation';          Params:'II';  Kind:fnNumber;       FT:esPermutation                      ;Hint:rsHint_Permutation             ;ParHint:rsPar_Permutation          ),

     // goniometric & Geometric
     (ID:0 ; Name:'Sin';                  Params:'R';   Kind:fnGonio;        FT:esSin                              ;Hint:rsHint_Sin                     ;ParHint:rsPar_Sin                  ),
     (ID:0 ; Name:'Cos';                  Params:'R';   Kind:fnGonio;        FT:esCos                              ;Hint:rsHint_Cos                     ;ParHint:rsPar_Cos                  ),
     (ID:0 ; Name:'Tan';                  Params:'R';   Kind:fnGonio;        FT:esTan                              ;Hint:rsHint_Tan                     ;ParHint:rsPar_Tan                  ),
     (ID:0 ; Name:'CoTan';                Params:'R';   Kind:fnGonio;        FT:esCoTan                            ;Hint:rsHint_CoTan                   ;ParHint:rsPar_CoTan                ),
     (ID:0 ; Name:'ArcSin';               Params:'R';   Kind:fnGonio;        FT:esArcSin                           ;Hint:rsHint_ArcSin                  ;ParHint:rsPar_ArcSin               ),
     (ID:0 ; Name:'ArcCos';               Params:'R';   Kind:fnGonio;        FT:esArcCos                           ;Hint:rsHint_ArcCos                  ;ParHint:rsPar_ArcCos               ),
     (ID:0 ; Name:'ArcTan';               Params:'R';   Kind:fnGonio;        FT:esArcTan                           ;Hint:rsHint_ArcTan                  ;ParHint:rsPar_ArcTan               ),
     (ID:0 ; Name:'ArcTan2';              Params:'RR';  Kind:fnGonio;        FT:esArcTan2                          ;Hint:rsHint_ArcTan2                 ;ParHint:rsPar_ArcTan2              ),
     (ID:0 ; Name:'Hypot';                Params:'RR';  Kind:fnGonio;        FT:esHypot                            ;Hint:rsHint_Hypot                   ;ParHint:rsPar_Hypot                ),
     (ID:0 ; Name:'DegToRad';             Params:'R';   Kind:fnGonio;        FT:esDegToRad                         ;Hint:rsHint_DegToRad                ;ParHint:rsPar_DegToRad             ),
     (ID:0 ; Name:'RadToDeg';             Params:'R';   Kind:fnGonio;        FT:esRadToDeg                         ;Hint:rsHint_RadToDeg                ;ParHint:rsPar_RadToDeg             ),
     (ID:0 ; Name:'GradToRad';            Params:'R';   Kind:fnGonio;        FT:esGradToRad                        ;Hint:rsHint_GradToRad               ;ParHint:rsPar_GradToRad            ),
     (ID:0 ; Name:'RadToGrad';            Params:'R';   Kind:fnGonio;        FT:esRadToGrad                        ;Hint:rsHint_RadToGrad               ;ParHint:rsPar_RadToGrad            ),
     (ID:0 ; Name:'CycleToRad';           Params:'R';   Kind:fnGonio;        FT:esCycleToRad                       ;Hint:rsHint_CycleToRad              ;ParHint:rsPar_CycleToRad           ),
     (ID:0 ; Name:'RadToCycle';           Params:'R';   Kind:fnGonio;        FT:esRadToCycle                       ;Hint:rsHint_RadToCycle              ;ParHint:rsPar_RadToCycle           ),
     (ID:0 ; Name:'CosH';                 Params:'R';   Kind:fnGonio;        FT:esCosh                             ;Hint:rsHint_Cosh                    ;ParHint:rsPar_Cosh                 ),
     (ID:0 ; Name:'SinH';                 Params:'R';   Kind:fnGonio;        FT:esSinh                             ;Hint:rsHint_Sinh                    ;ParHint:rsPar_Sinh                 ),
     (ID:0 ; Name:'TanH';                 Params:'R';   Kind:fnGonio;        FT:esTanH                             ;Hint:rsHint_TanH                    ;ParHint:rsPar_TanH                 ),
     (ID:0 ; Name:'ArcCosH';              Params:'R';   Kind:fnGonio;        FT:esArcCosh                          ;Hint:rsHint_ArcCosh                 ;ParHint:rsPar_ArcCosh              ),
     (ID:0 ; Name:'ArcSinH';              Params:'R';   Kind:fnGonio;        FT:esArcSinh                          ;Hint:rsHint_ArcSinh                 ;ParHint:rsPar_ArcSinh              ),
     (ID:0 ; Name:'ArcTanH';              Params:'R';   Kind:fnGonio;        FT:esArcTanH                          ;Hint:rsHint_ArcTanH                 ;ParHint:rsPar_ArcTanH              ),
     (ID:0 ; Name:'CircleO';              Params:'R';   Kind:fnGonio;        FT:esCircleO                          ;Hint:rsHint_CircleO                 ;ParHint:rsPar_CircleO              ),
     (ID:0 ; Name:'CircleP';              Params:'R';   Kind:fnGonio;        FT:esCircleP                          ;Hint:rsHint_CircleP                 ;ParHint:rsPar_CircleP              ),

     // Conversion
     (ID:0 ; Name:'String';               Params:'?'   ;Kind:fnConversion;   FT:esString                           ;Hint:rsHint_String                  ;ParHint:rsPar_String               ),
     (ID:0 ; Name:'Integer';              Params:'?'   ;Kind:fnConversion;   FT:esInteger                          ;Hint:rsHint_Integer                 ;ParHint:rsPar_Integer              ),
     (ID:0 ; Name:'Boolean';              Params:'?'   ;Kind:fnConversion;   FT:esBoolean                          ;Hint:rsHint_Boolean                 ;ParHint:rsPar_Boolean              ),
     (ID:0 ; Name:'Real';                 Params:'?'   ;Kind:fnConversion;   FT:esReal                             ;Hint:rsHint_Real                    ;ParHint:rsPar_Real                 ),
     (ID:0 ; Name:'NumberToSpell';        Params:'I'   ;Kind:fnConversion;   FT:esNumberToSpell                    ;Hint:rsHint_NumberToSpell           ;ParHint:rsPar_NumberToSpell        ),
     (ID:0 ; Name:'DateTimeToStr';        Params:'@'   ;Kind:fnConversion;   FT:esDateTimeToStr                    ;Hint:rsHint_DateTimeToStr           ;ParHint:rsPar_DateTimeToStr        ),
     (ID:0 ; Name:'DateTimeToString';     Params:'S@'  ;Kind:fnConversion;   FT:esDateTimeToString                 ;Hint:rsHint_DateTimeToString        ;ParHint:rsPar_DateTimeToString     ),
     (ID:0 ; Name:'DateToStr';            Params:'@'   ;Kind:fnConversion;   FT:esDateToStr                        ;Hint:rsHint_DateToStr               ;ParHint:rsPar_DateToStr            ),
     (ID:0 ; Name:'FloatToStr';           Params:'R'   ;Kind:fnConversion;   FT:esFloatToStr                       ;Hint:rsHint_FloatToStr              ;ParHint:rsPar_FloatToStr           ),
     (ID:0 ; Name:'CurrToStr';            Params:'R'   ;Kind:fnConversion;   FT:esCurrToStr                        ;Hint:rsHint_CurrToStr               ;ParHint:rsPar_CurrToStr            ),
     (ID:0 ; Name:'FormatFloat';          Params:'SR'  ;Kind:fnConversion;   FT:esFormatFloat                      ;Hint:rsHint_FormatFloat             ;ParHint:rsPar_FormatFloat          ),
     (ID:0 ; Name:'IntToHex';             Params:'II'  ;Kind:fnConversion;   FT:esIntToHex                         ;Hint:rsHint_IntToHex                ;ParHint:rsPar_IntToHex             ),
     (ID:0 ; Name:'StrToDate';            Params:'S'   ;Kind:fnConversion;   FT:esStrToDate                        ;Hint:rsHint_StrToDate               ;ParHint:rsPar_StrToDate            ),
     (ID:0 ; Name:'StrToDateTime';        Params:'S'   ;Kind:fnConversion;   FT:esStrToDateTime                    ;Hint:rsHint_StrToDateTime           ;ParHint:rsPar_StrToDateTime        ),
     (ID:0 ; Name:'StrToFloat';           Params:'S'   ;Kind:fnConversion;   FT:esStrToFloat                       ;Hint:rsHint_StrToFloat              ;ParHint:rsPar_StrToFloat           ),
     (ID:0 ; Name:'StrToCurr';            Params:'S'   ;Kind:fnConversion;   FT:esStrToCurr                        ;Hint:rsHint_StrToCurr               ;ParHint:rsPar_StrToCurr            ),
     (ID:0 ; Name:'StrToInt';             Params:'S'   ;Kind:fnConversion;   FT:esStrToInt                         ;Hint:rsHint_StrToInt                ;ParHint:rsPar_StrToInt             ),
     (ID:0 ; Name:'StrToTime';            Params:'S'   ;Kind:fnConversion;   FT:esStrToTime                        ;Hint:rsHint_StrToTime               ;ParHint:rsPar_StrToTime            ),
     (ID:0 ; Name:'IntToStr';             Params:'I'   ;Kind:fnConversion;   FT:esIntToStr                         ;Hint:rsHint_IntToStr                ;ParHint:rsPar_IntToStr             ),
     (ID:0 ; Name:'FloatToStrF';          Params:'RIII';Kind:fnConversion;   FT:esFloatToStrF                      ;Hint:rsHint_FloatToStrF             ;ParHint:rsPar_FloatToStrF          ),
     (ID:0 ; Name:'CurrToStrF';           Params:'RII' ;Kind:fnConversion;   FT:esCurrToStrF                       ;Hint:rsHint_CurrToStrF              ;ParHint:rsPar_CurrToStrF           ),
     (ID:0 ; Name:'FormatCurr';           Params:'SR'  ;Kind:fnConversion;   FT:esFormatCurr                       ;Hint:rsHint_FormatCurr              ;ParHint:rsPar_FormatCurr           ),
     (ID:0 ; Name:'TimeToStr';            Params:'@'   ;Kind:fnConversion;   FT:esTimeToStr                        ;Hint:rsHint_TimeToStr               ;ParHint:rsPar_TimeToStr            ),
     (ID:1 ; Name:'DecToRoman';           Params:'I'   ;Kind:fnConversion;   FT:esDecToRoman                       ;Hint:rsHint_DecToRoman              ;ParHint:rsPar_DecToRoman           ),

     // misc
     (ID:0 ; Name:'Cond'      ;           Params:'LXX' ;Kind:fnMisc;         FT:esCond                             ;Hint:rsHint_Cond                    ;ParHint:rsPar_Cond                 ),
     (ID:1 ; Name:'SysErrorMessage';      Params:'I'   ;Kind:fnMisc;         FT:esSysErrorMessage                  ;Hint:rsHint_SysErrorMessage         ;ParHint:rsPar_SysErrorMessage      ),
     (ID:1 ; Name:'GetLocaleStr';         Params:'II'  ;Kind:fnMisc;         FT:esGetLocaleStr                     ;Hint:rsHint_GetLocaleStr            ;ParHint:rsPar_GetLocaleStr         ),

     // financial
     (ID:2 ; Name:'DoubleDecliningBalance';  Params:'RRII'   ;Kind:fnFinancial; FT:esDoubleDecliningBalance        ;Hint:rsHint_DoubleDecliningBalance  ;ParHint:rsPar_DoubleDecliningBalance),
     (ID:2 ; Name:'FutureValue';             Params:'RIRRI'  ;Kind:fnFinancial; FT:esFutureValue                   ;Hint:rsHint_FutureValue             ;ParHint:rsPar_FutureValue           ),
     (ID:2 ; Name:'InterestPayment';         Params:'RIIRRI' ;Kind:fnFinancial; FT:esInterestPayment               ;Hint:rsHint_InterestPayment         ;ParHint:rsPar_InterestPayment       ),
     (ID:2 ; Name:'InterestRate';            Params:'IRRRI'  ;Kind:fnFinancial; FT:esInterestRate                  ;Hint:rsHint_InterestRate            ;ParHint:rsPar_InterestRate          ),
     //esInternalRateOfReturn          ernalRateOfReturn
     (ID:2 ; Name:'NumberOfPeriods';         Params:'RRRRI' ;Kind:fnFinancial; FT:esNumberOfPeriods                ;Hint:rsHint_NumberOfPeriods         ;ParHint:rsPar_NumberOfPeriods       ),
     //(Name:'NetPresentValuesNetPresentValue
     (ID:2 ; Name:'Payment';                 Params:'RIRRI' ;Kind:fnFinancial; FT:esPayment                        ;Hint:rsHint_Payment                 ;ParHint:rsPar_Payment               ),
     (ID:2 ; Name:'PeriodPayment';           Params:'RIIRRI';Kind:fnFinancial; FT:esPeriodPayment                  ;Hint:rsHint_PeriodPayment           ;ParHint:rsPar_PeriodPayment         ),
     (ID:2 ; Name:'PresentValue';            Params:'RIRRI' ;Kind:fnFinancial; FT:esPresentValue                   ;Hint:rsHint_PresentValue            ;ParHint:rsPar_PresentValue          ),
     (ID:2 ; Name:'SLNDepreciation';         Params:'RRI'   ;Kind:fnFinancial; FT:esSLNDepreciation                ;Hint:rsHint_SLNDepreciation         ;ParHint:rsPar_SLNDepreciation       ),
     (ID:2 ; Name:'SYDDepreciation';         Params:'RRII'  ;Kind:fnFinancial; FT:esSYDDepreciation                ;Hint:rsHint_SYDDepreciation         ;ParHint:rsPar_SYDDepreciation       )

     // here is place for description custom function

          );

var FunctionCount : Integer;

function GetFunctionByIndex(idx:Integer):TDefFun;
begin
     Result.Name    := '';
     Result.Params  := '';
     Result.FT      := esNone;
     Result.Kind    := fnNone;
     Result.ParHint :='';
     Result.Hint    :='';

     if (idx>=Low(DefFun)) and (idx<=High(DefFun)) then
        Result:=DefFun[idx];
end;

function GetFunctionByName(Name:String):TDefFun;
var i:Integer;
begin
     Result.Name    := '';
     Result.Params  := '';
     Result.FT      := esNone;
     Result.Kind    := fnNone;

     for i:=Low(DefFun) to FunctionCount do
         if CompareText(DefFun[i].Name,Name)=0 then begin
            Result :=DefFun[i];
            Exit;
         end;
end;

function  GetFunctionBySymbol(fn:TEvalSymbol):TDefFun;
var i:Integer;
begin
     Result.Name    := '';
     Result.Params  := '';
     Result.FT      := esNone;
     Result.Kind    := fnNone;
     Result.ID      := 0;

     for i:=Low(DefFun) to High(DefFun) do
         if DefFun[i].FT=fn then begin
            Result :=DefFun[i];
            Exit;
         end;
end;

function GetFunctionCount:Integer;
begin
     Result:=High(DefFun)-Low(DefFun)+1;
end;

function GetFnCall(idx:Integer):String;
var s,p:String;
    j  :Integer;
begin
  if (idx>=Low(DefFun)) and (idx<=High(DefFun)) then begin
     s:=DefFun[idx].Name;
     p:=DefFun[idx].Params;
     if DefFun[idx].Kind=fnOperators then begin
        if Length(p)=1 then s:=s+' Argument'
        else begin
             if DefFun[idx].FT in [esPlus,esMinus,esMultiply,esDivision,esAnd,esOr]
                then s:='argument1 '+s+' argument2 '+s+' argument3 '+s+' ...'
             else
                s:='argument1 '+s+' argument2';
        end
     end else begin
         if Length(p)>0 then s:=s+'(';
         for j:=1 to Length(p) do begin
             case p[j] of
                 '@' : s:=s+'DateTime';
                 'D' : s:=s+'Date';
                 'T' : s:=s+'Time';
                 'S' : s:=s+'String';
                 'R' : s:=s+'Real';
                 'I' : s:=s+'Integer';
                 'L' : s:=s+'Boolean';
                 'C' : s:=s+'Char';
                 'F' : s:=s+'FileName';
                 else  s:=s+'?';
             end;
             if (j<>Length(p)) and (p[j]<>' ') then s:=s+',';
         end;
         if Length(p)>0 then s:=s+')';
     end;
     Result:=s;
  end else
     Result:='';
end;


procedure GetFunctionList(L:TStrings);
var i:Integer;
begin
     L.BeginUpdate;
     L.Clear;
     for i:=Low(DefFun) to High(DefFun) do
         L.AddObject(GetFnCall(i),Pointer(i));
     L.EndUpdate;
end;

procedure GetFunctionNames(fn:TFnTypes; L:TStrings);
var i:Integer;
begin
  with L do begin
     BeginUpdate;
     Clear;
     for i:=Low(DefFun) to High(DefFun) do
         if (fnAll in fn) or (DefFun[i].Kind in fn) then
            AddObject(DefFun[i].Name,Pointer(i));
     EndUpdate;
  end;
end;

procedure GetFunctionGroup(L:TStrings);
var i:TFnType;
begin
     L.Clear;
     for i:=fnAll to High(FunctionGroup) do
        L.AddObject(FunctionGroup[i], Pointer(i));
end;

function GetFunctionGroupName(T:TFnType):String;
begin
     if (T>=Low(FunctionGroup)) and (T<=High(FunctionGroup)) then
                                Result:=FunctionGroup[T]
     else                       Result:='';
end;

procedure CreateFunctionHTML(FileName:String; Style:TEvalHtml);
var L,G,F : TStringList;
    s     : String;
    i,j,idx       : Integer;
    FN            : TDefFun;
    Columns       : Integer;
begin
    L:=TStringList.Create;
    try
       G:=TStringList.Create;
       try
         L.Add('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN>');
         L.Add('<HTML>');
         L.Add('<HEAD>');
         L.Add('<meta name="GENERATOR" content="PSOFT Eval components http://www.ke.telecom.sk/psoft">');
         L.Add('<TITLE>'+rsHTMLCaption+'</TITLE>');
         L.Add('</HEAD>');
         L.Add('<BODY bgColor="D0F0D0">');
         L.Add('<H2 align="center">'+rsHTMLcaption+'</H2>');
         L.Add('<HR>');
         Columns:=0;
         case Style of
              fnEvalHtmlTable, fnEvalHtmlTableWithCall : begin
                   L.Add('<TABLE>');
                   if Style=fnEvalHtmlTable then Columns:=2
                   else                          Columns:=3;
              end;
              fnEvalHtmlList                           : L.Add('<OL>');
              fnEvalHtmlText                           : ;
         end;

         GetFunctionGroup(G);
         for j:=1 to G.Count-1 do begin
            F:=TStringList.Create;
            try
               GetFunctionNames([TFnType(G.Objects[j])],F);
               if F.Count>0 then begin
                  case Style of
                    fnEvalHtmlTable, fnEvalHtmlTableWithCall :
                       L.Add('<TR><TD colspan='+IntToStr(Columns)+'>&nbsp;</TD></TR>'
                         +'<TR align="center" valign="bottom" bgcolor="Yellow">'
                         +'<TD colspan='+IntToStr(Columns)+'>'+Format('<B>%s</B>(%d)',[G.Strings[j],F.Count])+'</TD></TR>');
                    fnEvalHtmlList                           : L.Add(Format('<BR><LI><B>%s</B>(%d)<OL>',[G.Strings[j],F.Count]));
                    fnEvalHtmlText                           : ;
                  end;
                  for i:=0 to F.Count-1 do begin
                      idx:=Integer(F.Objects[i]);
                      FN:=GetFunctionByIndex(idx);
                      case Style of
                           fnEvalHtmlTable, fnEvalHtmlTableWithCall : begin
                              s:='<TR valign="top"><TD><B>'+FN.Name+'</B></TD><TD>'+FN.Hint+'</TD>';
                              if Style=fnEvalHtmlTableWithCall then
                                 s:=s+'<TD>'+GetFnCall(idx)+'</TD>';
                              s:=s+'</TR>';
                           end;
                           fnEvalHtmlList                           : s:='<LI><B>'+FN.Name+'</B>-'+FN.Hint;
                           fnEvalHtmlText                           : s:='<B>'+FN.Name+'</B>-'+FN.Hint+'<BR>';
                      end;
                      L.Add(s);
                  end;
                  if Style in [fnEvalHtmlList] then L.Add('</OL>');
               end;
            finally
               F.Free;
           end;
         end;

         case Style of
              fnEvalHtmlTable, fnEvalHtmlTableWithCall : L.Add('</TABLE>');
              fnEvalHtmlList                           : L.Add('</OL>');
              fnEvalHtmlText                           : ;
         end;
         L.Add('<HR>');
         L.Add('</BODY>');
         L.Add('</HTML>');
         L.SaveToFile(FileName);
       finally
         G.Free;
       end;
    finally
       L.Free;
    end;
end;

initialization

  FunctionCount:=High(DefFun)-Low(DefFun)+1;

end.


// FPower10
// Norm
// Random
// CharSetToIdent
// PChar funkcie - napr. AnsiLastChar

